
jQuery(document).ready(function($){

	debug = true;

	function consolelog(d){
		if (debug)
			console.log(d);
	}

	$(".wp-mfc-linkator-button-add-link").click(function() {
		if ($(this).data('href')){
			var ankor = tinyMCE.activeEditor.selection.getContent();
			if (ankor.length){
				var title = $(this).data('title')? ' title="'+$(this).data('title')+'"' : '';
				var target = $(this).data('target')? ' target="_blank"' : '';
				wp.media.editor.insert('<a href="'+$(this).data('href')+'"'+title+target+'>'+ankor+'</a>');
			}
		}
	});

	$('.wp-mfc-linkator-menu a').click(function(){
		$('.wp-mfc-linkator-menu a').removeClass('active');
		$(this).addClass('active');
	});

	$('#linkator-search').submit(function(){
		return false;
	});
	$('#linkator-search input[type=submit]').click(function(){
		$('#linkator_table tbody, .paginator').html('');
		var $a = $('#linkator-search .post_type input:checkbox:checked');
		var $c = $('#linkator-search .categories input:checkbox:checked');
		if (!$a.length){
			alert('Не выбраны типы постов');
			return false;
		}
		if (!$('#linkator-search input[name="phrase"]').val().length){
			alert('Не указана поисковая фраза');
			return false;
		}
		if (!$('#linkator-search input[name="href"]').val().length){
			alert('Не указан url страницы, на которую ссылаться');
			return false;
		}

		var post_type = new Array;
		for(i=0; i< $a.length; i++)
			post_type.push($($a[i]).val());

		var cats = new Array;
		for(i=0; i< $c.length; i++)
			cats.push($($c[i]).val());

		var search = $('#linkator-search input[name="phrase"]').val();

		$('.bg_gray, .loading').fadeIn(300);

		$.post(
			ajaxurl,
			{
				action: 'mfc_search_action',
				nameform: 'linkator_search',
				post_type: post_type,
				categories: cats,
				search: search,
				predlog: $('#linkator-search input[name="predlog"]').val(),
				href: $('#linkator-search input[name="href"]').val(),
				title: $('#linkator-search input[name="title"]').val(),
				blank: $('#linkator-search input[name="blank"]:checked').length
			},
			function(d){
				$('.bg_gray, .loading').fadeOut(300);
				d = $.parseJSON(d);
				consolelog(d);

				if (d.status == 'fail'){
					alert(d.mess);
					return false;
				}

				str = $('#linkator-search input[type=text]').val();
				var posts = d.posts;
				$('#linkator_table tbody').html('');
				$('#linkator-search button').html('Скрыть записи с ссылками');
				var $p = 1;
				for(var i in posts){
					var page = Math.ceil($p/20);
					var target = $('[name="blank"]:checked').length;
					$('#linkator_table tbody').append(
						'<tr id="tr'+i+'"'+(posts[i].is_link? ' class="is_link" style="font-weight:bold"' : '')+' data-page="'+page+'">' +
							'<td>' + $p + '</td>' +
							'<td>'+posts[i].post_type+' / '+i+'</td>' +
							'<td align="center" title="'+(posts[i].cnt_link? 'Всего '+ posts[i].cnt_link + ', с анкором ' : '-') + (posts[i].is_link_key? posts[i].is_link_key : '-') + '">'+(posts[i].cnt_link? posts[i].cnt_link : '-') + ' / ' + (posts[i].is_link_key? posts[i].is_link_key : '-') + '</td>' +
							'<td id="td'+i+'" class="link"><a href="/wp-admin/options-general.php?page=wp_mfc_linkator&post_id='+i+'&search='+search+'&href='+$('#linkator-search input[name="href"]').val()+'&title='+$('#linkator-search input[name="title"]').val()+'&target='+target+'#wp-mfc-linkator-edit" target="_blank" class="wp-mfc-linkator-open-page">Редактировать</a>'+(posts[i].is_link? ' (link)' : '')+'</td>' +
							'<td>'+posts[i].post_title+'</td>' +
						'</tr>'
					);
					$p++;
				}
				var paginator = '';
				for (i=1; i<=page; i++)
					paginator += '<a href="#" data-page="'+i+'"'+(i==1? ' class="active"' : '')+'>'+i+'</a>';
				
				if (page>1)
					paginator += '<a href="#" class="showall">Показать все</a>'

				$('.paginator').html('Страницы: ' + paginator );
				$('#linkator_table tbody tr').hide();
				$('#linkator_table tbody tr[data-page=1]').show();
			}
		);
		return false;
	});

	$('[name="blank"]').change(function(){
		var checked = $('[name="blank"]:checked').length;
		$.each($('#linkator_table .link'), function(){
			if (checked)
				$(this).find('a').attr('href', $(this).find('a').attr('href').replace('&target=0', '&target=1'));
			else
				$(this).find('a').attr('href', $(this).find('a').attr('href').replace('&target=1', '&target=0'));

		});
	});

	$('body').on('click', '.paginator a', function(){
		if ($(this).hasClass('active'))
			return;
		$('.paginator a').removeClass('active');
		$(this).addClass('active');
		if ($(this).hasClass('showall'))
			$('#linkator_table tbody tr').show();
		else{
			$('#linkator_table tbody tr').hide();
			$('#linkator_table tbody tr[data-page='+$(this).data('page')+']').show();
		}
		return false;
	});

	$('#linkator-search button').click(function(){
		if ($(this).html() == 'Скрыть записи с ссылками'){
			$('#linkator_table tr.is_link').hide();
			$(this).html('Отобразить записи с ссылками');
		}else{
			$('#linkator_table tr.is_link').show();
			$(this).html('Скрыть записи с ссылками');
		}
	});

	$('#linkator-searchlink').submit(function(){
		$('#linkator_table tbody').html('');
		var $a = $('#linkator-searchlink input:checkbox:checked');
		if (!$a.length){
			alert('Не выбраны типы постов');
			return false;
		}
		if (!$('#linkator-searchlink input[name="link"]').val().length){
			alert('Не указан URL для поиска');
			return false;
		}

		var post_type = new Array;
		for(i=0; i< $a.length; i++)
			post_type.push($($a[i]).val());

		var search = $('#linkator-searchlink input[name="link"]').val();
		var pos = search.indexOf('?');
		if (pos > 0)
			search = search.substr(0, pos);

		$('.bg_gray, .loading').fadeIn(300);

		$.post(
			ajaxurl,
			{
				action: 'mfc_searchlink_action',
				nameform: 'linkator_searchlink',
				post_type: post_type,
				search: search
			},
			function(d){
				$('.bg_gray, .loading').fadeOut(300);
				d = $.parseJSON(d);
				consolelog(d);

				if (d.status == 'fail'){
					alert(d.mess);
					return false;
				}

				var posts = d.posts;
				$('#linkator_table tbody').html('');
				var $p = 1;
				for(var i in posts){
					$('#linkator_table tbody').append(
						'<tr id="tr'+i+'">' +
							'<td>' + $p + '</td>' +
							'<td>'+posts[i].post_type+' / '+i+'</td>' +
							'<td id="td'+i+'"><a href="/wp-admin/options-general.php?page=wp_mfc_linkator&searchlink=1&post_id='+i+'&search='+search+'#wp-mfc-linkator-edit" target="_blank" class="wp-mfc-linkator-open-page">Редактировать</a></td>' +
							'<td>'+posts[i].post_title+'</td>' +
						'</tr>'
					);
					$p++;
				}
			}
		);
		return false;
	});

	$('body').on('click', '.wp-mfc-linkator-open-page', function(){
		$(this).addClass('active');
	});

	$('.select-all').click(function(){
		$(this).parents('tr').find('input[type="checkbox"], input[type="checkbox"]').attr('checked', 'checked');
		return false;
	});
	$('.unselect-all').click(function(){
		$(this).parents('tr').find('input[type="checkbox"], input[type="checkbox"]').removeAttr('checked');
		return false;
	});

	$('.select-all-cat').click(function(){
		$(this).parents('tr').find('input[type="checkbox"], input[type="checkbox"]').attr('checked', 'checked');
		return false;
	});
	$('.unselect-all-cat').click(function(){
		$(this).parents('tr').find('input[type="checkbox"], input[type="checkbox"]').removeAttr('checked');
		return false;
	});

	function savePage(){
		for (i=0; i<tinyMCE.editors.length; i++) {
			var id = tinyMCE.editors[i].id
			$('textarea#' + id).html(tinyMCE.editors[i].getContent().replace('<sprtkyan style="background: #FBC59D;">','').replace('</sprtkyan>',''));
		}
		$.post(
			ajaxurl,
			$('#wp-mfc-linkator-save-post').serialize(),
			function(d){
				consolelog(d);
				d = $.parseJSON(d);
				consolelog(d);
				if (d.status == 'fail')
					alert(d.mess);
				else
					alert('Запись сохранена в базе сайта');
			}
		);
	}

	$('.wp-mfc-linkator-save-post-button').click(function(){
		savePage();
		return false;
	});
	$('#wp-mfc-linkator-save-post').submit(function(){
		return false;
	});

	
	$(window).on('keydown', function(event) {  // вне редактора
	    if (event.ctrlKey || event.metaKey) {
	        if (String.fromCharCode(event.which).toLowerCase() == 's') {
	            event.preventDefault();
	            savePage();
	        }
	    }
	});
	
	//$(document).bind('keydown', 'ctrl+s', function(){savePage();});
	
	if (typeof tinyMCE != 'undefined'){
		setTimeout(function(){
			for (i=0; i<tinyMCE.editors.length; i++) {
				tinyMCE.editors[i].shortcuts.add('ctrl+s', '', function() {savePage()});;
			}
		}, 1000);
	}

	// формирование ссылки в яндекс
	function createLinkForYandex(ths){
		if ($(ths).length){
			var $key = $(ths).val();
			$('.searchinya').html('Запрос в Яндексе <a href="https://yandex.ru/search/?text=site%3A'+location.hostname+'%20'+$key.replace(' ', '%20')+'" target="_blank">site:'+location.hostname+' '+$key+'</a>');
		}else{
			$('.searchinya').html('');
		}
	}
	$('input[name="phrase"]').keyup(function(e){
		createLinkForYandex(this)
	});
	$('input[name="phrase"]').change(function(){
		createLinkForYandex(this)
	});
	$('.wrap.linkator .right').css('height', $('.wrap.linkator').height()).append('<iframe width="100%" height="100%" src="//client.mfc.agency/adds/3"></iframe>')
});