<?php
/*
Plugin Name: wp-mfc-linkator
Plugin URI: http://mfc.agency/linkator-lp/
Author: mfc.agency - разработка плагинов для WordPress и софта для вебмастеров
Author URI: http://mfc.agency/
Description: WP-MFC Linkator Plugin – это плагин для удобной и быстрой ручной перелинковки записей и/или  страниц для любого типа сайтов на wordpress.
Version: 1.8
*/

class wp_mfc_linkator{

	static $version="1.8";

	public function __construct(){
		if (is_admin()){
			add_action('admin_menu', array($this, 'admin_settings'));
			add_action('admin_enqueue_scripts', array($this, 'admin_enqueue_script'));
			add_action('wp_ajax_mfc_search_action', array($this, 'ajax_search_action'));
			add_action('wp_ajax_mfc_searchlink_action', array($this, 'ajax_searchlink_action'));
			add_action('wp_ajax_mfc_save_post_action', array($this, 'ajax_save_post_action'));

		}
		add_action('init', array($this, 'init'));
		add_action('admin_init', array($this, 'check_update'));
	}

	function admin_settings(){
		add_options_page('Линкатор', 'Линкатор', 'moderate_comments', 'wp_mfc_linkator', array($this, 'linkator'));
	}

	public function check_update(){
		if (!class_exists('PucFactory')) {
			require 'plugin-updates/plugin-update-checker.php';
		}

		$update_file= 'http://client.mfc.agency/update/plugins/wp-mfc-linkator/info.json';

		$wpmfc_gi_update_checker= PucFactory::buildUpdateChecker(
			$update_file,
			__FILE__,
			'wp-mfc-linkator'
		);
	}
	function linkator(){
		global $wpdb;
		if (isset($_GET['post_id']) and is_numeric($_GET['post_id']) and $_GET['post_id']){
			$res = $wpdb->get_row('select post_content, post_title from ' . $wpdb->posts . ' where ID='.$_GET['post_id'] , ARRAY_A);
			$cont = $res['post_content'];
			$title = $res['post_title'];

			add_action('media_buttons', array($this, 'add_button_shortcode'), 11);

			if (strpos("\r", $cont))
				$cont = str_replace("\n\n", "\n", str_replace("\r", "\n", $cont));

			// исправление ul для корректного отображения в редакторе
			$cont = $this->replace_ol_ul($cont);

			//die($cont);

			$ar = explode("\n", $cont);
			if (isset($_GET['href']))
				include 'tmpl_post.php';
			else
				include 'tmpl_postsearchlink.php';
		}elseif (isset($_GET['searchlink'])){
			$typepost = $wpdb->get_results('select distinct post_type from ' . $wpdb->prefix . 'posts where post_type <> "revision" and post_type <> "attachment"', ARRAY_A);
			include 'tmpl_searchlink.php';
		}else{
			$typepost = $wpdb->get_results('select distinct post_type from ' . $wpdb->prefix . 'posts where post_type <> "revision" and post_type <> "attachment"', ARRAY_A);
			$terms = $wpdb->get_results('select tm.term_taxonomy_id, t.name from ' . $wpdb->prefix . 'terms t left join ' . $wpdb->prefix . 'term_taxonomy tm on t.term_id=tm.term_id where tm.taxonomy = "category" order by name', ARRAY_A);
			//pre($typepost);
			//print_r($terms);
			include 'tmpl_linkator.php';
		}
	}

	function admin_enqueue_script(){
		wp_enqueue_script('linkator_admin_js', plugins_url('/script.js', __FILE__), array('jquery'));
		wp_register_style( 'wpMfcLinkatorStyle', plugins_url('style.css', __FILE__) );
		wp_enqueue_style( 'wpMfcLinkatorStyle' );
	}

	function ajax_search_action(){
		if (empty($_POST['post_type']))
			die( json_encode(array('status' => 'fail', 'mess' => 'Не выбраны типы постов')));

		global $wpdb;
		$terms = array();
		$andWhere = '';
		if (isset($_POST['categories']) and count($_POST['categories'])){
			$terms = implode(',', $_POST['categories']);
			$andWhere = 'AND ID in (
					SELECT object_id
					FROM ' . $wpdb->prefix . 'term_relationships
					WHERE term_taxonomy_id in ('.$terms.')
				)';
		}


		//print_r($_POST);

		foreach ($_POST['post_type'] as &$value)
			$value = '"' . $value . '"';

		update_option('wp-mfc-linkator-predlog', $_POST['predlog']);
		update_option('wp-mfc-linkator-search', $_POST['search']);
		update_option('wp-mfc-linkator-post_type', $_POST['post_type']);
		update_option('wp-mfc-linkator-categories', $_POST['categories']);
		update_option('wp-mfc-linkator-href', $_POST['href']);
		update_option('wp-mfc-linkator-title', $_POST['title']);
		update_option('wp-mfc-linkator-blank', $_POST['blank']);

		$s = explode(' ', $_POST['search']);
		foreach ($s as &$value)
			//$value = '[[:<:]]'.$value.'[[:alpha:]]*';
			$value = '[[:punct:]]*[[:<:]]'.$value.'[[:alpha:]]*';

		$s2 = '';
		if (empty($_POST['predlog'])){
			$s = implode('[[:space:]]+', $s);
		}else{
			$s2 = implode('[[:space:]]+', $s);
			$s = implode('[[:space:]]+([[:<:]]'.$_POST['predlog'].'[[:>:]])[[:space:]]+', $s);
		}

		$q = '
			SELECT *
			FROM '.$wpdb->posts.'
			
			WHERE
				`post_content` REGEXP  "'.$s.'"
				AND (post_type in ('.implode(',', $_POST['post_type']).'))
				'.$andWhere.'
		';
		if ($s2)
			$q .= '
				UNION ALL

				SELECT *
				FROM '.$wpdb->posts.'
				WHERE
					`post_content` REGEXP  "'.$s2.'"
					AND (post_type in ('.implode(',', $_POST['post_type']).'))
					'.$andWhere.'

				ORDER BY `ID`
			';

		//echo $q;

		$res = $wpdb->get_results($q, ARRAY_A);
		//pre($res);
		if (!count($res))
			die( json_encode(array('status' => 'fail', 'mess' => 'По данному запросу записи не найдены')));

		$href = $_POST['href'];
		if (mb_strpos($_POST['href'], $_SERVER['SERVER_NAME']) !== false){ // абсолютная ссылка на страницу этого сайта (присутствует имя домена)
			$href = str_replace(array('http://', 'https://', $_SERVER['SERVER_NAME']), '', $href); // делаем ссылку относительной .
		}

		$a = explode(' ', $_POST['search']);
		foreach ($a as $key => &$val)
			if ($key != (count($a)-1))
				$val .= '\S*';
		$search = implode('\s+(' . get_option('wp-mfc-linkator-predlog') . ')\s+', $a);
		$search2 = implode('\s+', $a);

		$ar = array();
		foreach ($res as $key => $value) {
			if (mb_strpos($_POST['href'], '/'.$value['post_name']) === false){ // кроме ссылок на найденную страницу

				$cont = $value['post_content'];
				
				if ((substr_count($cont, '<ul')!=substr_count($cont, '</ul')) or (substr_count($cont, '<ol')!=substr_count($cont, '</ol')) or (substr_count($cont, '<li')!=substr_count($cont, '</li')))
					die( json_encode(array('status' => 'fail', 'mess' => 'В посте ID='.$value['ID'].' ( "' . $value['post_title'] . '" ) некорректная верстка! Не получается обработать пост.')));

				$cont = $this->replace_ol_ul($cont, $value['ID']);

				$arvalue = preg_split("/(<[^>]*>)/iu", $cont, -1, PREG_SPLIT_DELIM_CAPTURE); // бьем на куски разделенные тегами
				$find = false;
				foreach ($arvalue as $v) { // перебираем разбитый на подстроки массив
					if (mb_strpos($v, '<') !== 0){ // первый символ не "<" - значит не тег, а просто текст. Можно делать подсветку
						if (preg_match("/".$search."/ui", $v)){ //что-то получилось здесь найти
							$find = true;
						}elseif (preg_match("/".$search2."/ui", $v)){ // нашли что-то здесь
							$find = true;
						}
					}
				}
				if ($find){
					$ar[$value['ID']] = array('post_title' => '<a href="'.get_permalink($value['ID']).'" target="_blank">'.$value['post_title'].'</a>', 'post_type' => $value['post_type']);
					if (mb_strpos($value['post_content'], $href) !== false)
						$ar[$value['ID']]['is_link'] = 1;

					preg_match_all('/<a\s*href/ui', $value['post_content'], $a, PREG_PATTERN_ORDER);
					if (count($a[0]))
						$ar[$value['ID']]['cnt_link'] = count($a[0]);

					
					preg_match_all('/<a.*[^>]>.*' . trim($_POST['search']) . '.*<\/a>/ui', $value['post_content'], $a, PREG_PATTERN_ORDER);
					if (count($a[0]))
						$ar[$value['ID']]['is_link_key'] = count($a[0]);
				}
			}
		}
		die( json_encode(array('status' => 'success', 'posts' => $ar)) );
	}

	function ajax_searchlink_action(){
		
		if (empty($_POST['post_type']))
			die( json_encode(array('status' => 'fail', 'mess' => 'Не выбраны типы постов')));

		//print_r($_POST); die;

		foreach ($_POST['post_type'] as &$value)
			$value = '"' . $value . '"';

		$search = $_POST['search'];
		if (mb_strpos($search, $_SERVER['SERVER_NAME']) !== false){ // абсолютная ссылка на страницу этого сайта (присутствует имя домена)
			$search = str_replace(array('http://', 'https://', $_SERVER['SERVER_NAME']), '', $search); // делаем ссылку относительной .
		}
		if (($pos = mb_strpos($search, "?")) !== false){ // абсолютная ссылка на страницу этого сайта (присутствует имя домена)
			$search = mb_substr($search, 0, $pos); // убираем из ссылки все параметры
		}
		//print_r($search); 
		global $wpdb;
		//print_r($wpdb); die;
		$q = '
			select ID, post_type, post_title, post_name
			from ' . $wpdb->prefix . 'posts
			where
				(post_type in ('.implode(',', $_POST['post_type']).'))
				and post_status = "publish"
				and post_content like "%'.$wpdb->_real_escape($search).'%"
			order by ID -- limit 2';

		$res = $wpdb->get_results($q, ARRAY_A);
		if (!count($res))
			die( json_encode(array('status' => 'fail', 'mess' => 'По данному запросу записи не найдены')));

		$permalink = get_option('permalink_structure');

		$ar = array();
		foreach ($res as $key => $value) {
			$url = get_permalink($value['ID']);
			$url = str_replace(array('http:', 'https:'), '', $url);

			$ar[$value['ID']] = array('post_title' => '<a href="'.$url.'" target="_blank">'.$value['post_title'].'</a>', 'post_type' => $value['post_type']);
		}
		die( json_encode(array('status' => 'success', 'posts' => $ar)) );
	}

	function ajax_save_post_action(){
		if (isset($_POST['post_id']) and is_numeric($_POST['post_id']) and $_POST['post_id']){

			global $wpdb;
			$res = $wpdb->get_row('select post_content, post_title from ' . $wpdb->posts . ' where ID='.$_POST['post_id'] , ARRAY_A);
			$title = $res['post_title'];
			$cont = $res['post_content'];

			if (strpos("\r", $cont))
				$cont = str_replace("\n\n", "\n", str_replace("\r", "\n", $cont));

			// исправление ul для корректного отображения в редакторе
			$cont = $this->replace_ol_ul($cont);
			//die($cont);


			$ar = explode("\n", $cont);
			foreach ($_POST as $key => $value) {

				if (mb_strpos($key, 'str_') !== false){
					$value = stripslashes($value);
					//echo $value . "\n\n"; //  <span class="wp-mfc-linkator-orange" style="background: #FBC59D;">
					$value = str_replace(array('<sprtkyan style="background: #FBC59D;">', '</sprtkyan>'), '', $value);

					$key = str_replace('str_', '', $key);
					$ar[$key] = $value;
				}
			}
			$cont = implode("\n", $ar);

			// записываем результат в базу
			$wpdb->update(
				$wpdb->posts,
				array('post_content' => stripslashes($cont)),
				array('ID' => $_POST['post_id'])
			);
			die( json_encode(array('status' => 'success')));
		}

		die( json_encode(array('status' => 'fail', 'mess' => 'Запись для обновления не найдена')));
	}

	function init(){

		add_filter('teeny_mce_before_init', 'f_teeny_mce_before_init', 10, 2);
		function f_teeny_mce_before_init($mceInit, $editor_id){
			$mceInit['extended_valid_elements'] = 'sprtkyan[*]';
			//pre($mceInit);
			return $mceInit;
		}
		if (isset($_POST['nameform'])){
			global $wpdb;
			header('Content-Type: text/html; charset=utf-8');
			if ($_POST['nameform'] == 'linkator_get_post'){
				if (empty($_POST['str']))
					die( json_encode(array('status' => 'fail', 'mess' => 'Пустая фраза')));

				if (empty($_POST['id']))
					die( json_encode(array('status' => 'fail', 'mess' => 'Не указан id записи')));

				$res = $wpdb->get_row('select post_content from ' . $wpdb->prefix . 'posts where ID=' . (int)$_POST['id'], ARRAY_A);
				$cont = $res['post_content'];

				if (strpos($cont, $_POST['str']) === false)
					die( json_encode(array('status' => 'success', 'find' => 0, 'id' => $_POST['id'])));


				//print_r($str);
				die( json_encode(array('status' => 'success', 'find' => 1, 'id' => $_POST['id'], 'search' => $_POST['str'])));

			}else if ($_POST['nameform'] == 'wp-mfc-linkator-save-post'){
				//print_r($_POST);

			}

		}
	}

	function replace_ol_ul($cont , $id=null){
		$ul1 = $ul2 = 0;
		$max_char = mb_strlen($cont);
		//echo $max_char;
		$i = 0;
		while (($ul2 < $max_char) and ($ul1 = mb_strpos ($cont, '<ul', $ul1+1)) !== false){

			$ul2 = mb_strpos ($cont, '</ul>', $ul2)+5;
			$substr = mb_substr ($cont, $ul1, $ul2-$ul1);
			$substr = str_replace(array("\r", "\n", "\t"), '', $substr);

			$i++;
			//echo $i . '. === ' . $id . ' ul === ' . $max_char . ' === ' . $ul1 . ' === ' . $ul2 . ' === ' . $substr . "\n";

			//die($substr);
			$cont = mb_substr ($cont, 0, $ul1) . $substr . mb_substr ($cont, $ul2);
			$ul2 = $ul1 + mb_strlen($substr);
			$max_char = mb_strlen($cont);
		}
		$ul1 = $ul2 = 0;
		$i = 0;
		while (($ul2 < $max_char) and ($ul1 = mb_strpos ($cont, '<ol', $ul1+1)) !== false){
			$ul2 = mb_strpos ($cont, '</ol>', $ul2)+5;
			$substr = mb_substr ($cont, $ul1, $ul2-$ul1);
			$substr = str_replace(array("\r", "\n", "\t"), '', $substr);

			$i++;
			//echo $i . '. === ' . $id . ' ol === ' . $max_char . ' === ' . $ul1 . ' === ' . $ul2 . ' === ' . $substr . "\n";

			//die($substr);
			$cont = mb_substr ($cont, 0, $ul1) . $substr . mb_substr ($cont, $ul2);
			$ul2 = $ul1 + mb_strlen($substr);
			$max_char = mb_strlen($cont);
		}
		$ul1 = $ul2 = 0;
		$i = 0;
		while (($ul2 < $max_char) and ($ul1 = mb_strpos ($cont, '<table', $ul1+1)) !== false){
			$ul2 = mb_strpos ($cont, '</table>', $ul2)+8;
			$substr = mb_substr ($cont, $ul1, $ul2-$ul1);
			$substr = str_replace(array("\r", "\n", "\t"), '', $substr);

			$i++;
			//echo $i . '. === ' . $id . ' table === ' . $max_char . ' === ' . $ul1 . ' === ' . $ul2 . ' === ' . $substr . "\n";

			//die($substr);
			$cont = mb_substr ($cont, 0, $ul1) . $substr . mb_substr ($cont, $ul2);
			$ul2 = $ul1 + mb_strlen($substr);
			$max_char = mb_strlen($cont);
		}
		return $cont;
	}

	public function add_button_shortcode(){
		if (isset($_GET['href'])){
			echo '<button class="wp-mfc-linkator-button-add-link" data-href="'.$_GET['href'].'" data-title="'.$_GET['title'].'" data-target="'.$_GET['target'].'">link</button>';
		}
	}

}

$tve_phoneBase = new wp_mfc_linkator;
